/******************************************************************************\
*
* File:          VoxelDemoA.h
* Creation date: September 07, 2003 23:02
* Author:        ClassBuilder
*                XXXX
* Purpose:       Declaration of class 'VoxelDemo'
*
* Modifications: @INSERT_MODIFICATIONS(* )
* September 07, 2003 23:02 Initial
*     Updated member 'Depth'
*     Updated member 'Width'
*     Updated member 'HeightBuffer'
*     Updated member 'TextureBuffer'
*     Updated member 'BackBuffer'
*     Updated member 'HeightData'
*     Updated member 'TextureData'
*     Updated member 'm_display'
*
* Copyright 2003, XXXXX
* All rights are reserved. Reproduction in whole or part is prohibited
* without the written consent of the copyright owner.
*
\******************************************************************************/
#ifndef _VOXELDEMOA_H
#define _VOXELDEMOA_H

//@START_USER1
//@END_USER1



class VoxelDemo
    : public Game
{

//@START_USER2
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Group: Constructors and Destructor
//

public:
    VoxelDemo();
    virtual ~VoxelDemo();

//
// Group: Attributes
//

private:
    Surface::LockInfo BackBuffer;
    int Depth;
    Surface::LockInfo HeightBuffer;
    Surface* HeightData;
    Surface::LockInfo TextureBuffer;
    DisplayDevice* m_display;
    Surface* TextureData;
    int Width;

//
// Group: Initialization Methods
//

public:
    virtual void InitHeightMap();
    virtual void InitTables();

//
// Non-Grouped Members
//

//
// Non-Grouped Methods
//

public:
    virtual void DrawTerrain(int play_x, int play_y, int play_z, int play_ang,
                             int play_dist, Pixel* buffer, Pixel* texture,
                             unsigned char* height);
    virtual void GameEnd();
    virtual bool GameInit();
    virtual void GameLoop();
};

#endif


#ifdef CB_INLINES
#ifndef _VOXELDEMOA_H_INLINES
#define _VOXELDEMOA_H_INLINES

//@START_USER3
//@END_USER3

#endif
#endif
